var Cus02100_AnaliseDeCusto = function(General, GeneralServices, templateManager, ZhUtil, CUSUtilities) {
    /*global moment Configuration getLocalVar*/
    this.defaultValues = function(widget) {
        let firstReport = widget.getField('CD_REPORT_NAME').dataSource.getFirstRow();
        let currentDate = moment().format('DD/MM/YYYY');       
        
        widget.currentRow.CD_REPORT_NAME = firstReport.value;
        widget.currentRow.NMFILIAL = getLocalVar('CDFILIAL') + " | " + getLocalVar('NMFILIAL');
        widget.currentRow.CDFILIAL = widget.currentRow.NMFILIAL.substring(0, 4);
        widget.getField('NMTIPOCUSTO').reload().then(callback => {
            let typeOfCost = callback.dataset.type_cost_lang;
            
            if(typeOfCost && typeOfCost.length){
                let currentCost = typeOfCost[0];
                widget.currentRow.NMTIPOCUSTO = currentCost.CDTIPOCUSTO + ' | ' + currentCost.NMTIPOCUSTO;
                widget.currentRow.CDTIPOCUSTO = currentCost.CDTIPOCUSTO;
            }
        });        
        
        widget.getField('PERIODO').value(
			{
				'start': currentDate,
				'end': currentDate,
				'formattedEnd': currentDate,
				'formattedStart': currentDate
			}
		);
		
		widget.currentRow.DTINICIAL = currentDate;
		widget.currentRow.DTFINAL = currentDate;	
		let serviceField = widget.getField('NMSERVICO');
		this.changeServiceFilter(widget, serviceField);
    };
    
    this.unityOnChange = function(args) {
        let field = args.owner.field;  
        let widget = field.widget;
        widget.currentRow.CDFILIAL = field.value().substring(0, 4);
        widget.getField('NMSERVICO').clearValue();
        if (!field.value()) {
            widget.currentRow.CDFILIAL = '';
        }
        
        let serviceField = widget.getField('NMSERVICO');
		this.changeServiceFilter(widget, serviceField);
    };
    
    this.changeServiceFilter = function(widget, field) {
        field.dataSourceFilter = [];
        field.dataSourceFilter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: widget.currentRow.CDFILIAL
            },
            {
                name: "NRORG",
                operator: "=",
                value: getLocalVar('NRORG')
            }        
        ];
        
        field.reload();
    };
    
    this.onChangeDateValue = function(field) {
        if(field.value()){
            field.widget.currentRow.DTINICIAL = field.value().start || '';
            field.widget.currentRow.DTFINAL = field.value().end || '';
        }        
    }; 
    
    this.validateFields = function(widget, row, currentRow) {
        if(widget.isValid()) {
            let reportName = widget.currentRow.CD_REPORT_NAME;
            row.DTCUSTPADR = moment(currentRow.PERIODO.end, 'DD/MM/YYYY').startOf('month').format('DD/MM/YYYY');
      		var reportFormats = [
          	    {
        	        name: "pdf",
        	        value: "PDF"
          	    },
    		    {
        	        name: "xlsx",
        	        value: "XLSX"
    		    }
      		];
  	
  		    General.openReportPopup(widget, this.abreRelatorio, [reportName, row, currentRow], reportFormats);            
        }
    };
    
	this.abreRelatorio = function(reportName, row, currentRow) {
		General.openReport('cus_relatorio#/Cus02100_AnaliseDeCusto', reportName, row);
	}.bind(this);      
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus02100_AnaliseDeCusto', Cus02100_AnaliseDeCusto);
});